//+------------------------------------------------------------------+
//|                                                   CirclePips.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                  https://www.mql5.com/ru/users/nikolay7ko/seller |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com/ru/users/nikolay7ko/seller"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas_CB.mqh> //https://www.mql5.com/ru/code/22164
//input double K = 1.0;
int OnInit() {
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
   return(rates_total);
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam) {
   static bool modyfi = true;
   if(id == CHARTEVENT_CLICK) modyfi = !modyfi;
   if(id == CHARTEVENT_MOUSE_MOVE && modyfi) DrawCircle();
}
//+------------------------------------------------------------------+
void DrawCircle() {
   Canvas.Erase(0x00FFFFFF);
   double x = _X(W.MouseBar);
   double y = _Y(Canvas.Close(W.MouseX));
   double point_in_pixel = (W.Y_max-W.Y_min)/(_Point*W.Height);
   double r= (0.3*(W.Y_max-W.Y_min)*W.MouseY/W.Height+0.05*(W.Y_max-W.Y_min))/_Point;
   double ry = r/point_in_pixel;
   double rx =W.dx_pix*r*60/PeriodSeconds();
   Canvas.FillEllipse(int(x-rx),int(y-ry),int(x+rx),int(y+ry),0x80FF20FF);
   _CommXY(int(x),int(y-ry-20),string(Round(r)) + " pips");
   Canvas.Update();
}
//+------------------------------------------------------------------+
